<?php

namespace App\Filament\Resources\Panel;

use Filament\Forms;
use Filament\Tables;
use Livewire\Component;
use Filament\Forms\Form;
use App\Models\Employee;
use Filament\Tables\Table;
use Filament\Resources\Resource;
use Filament\Forms\Components\Grid;
use Filament\Forms\Components\Section;
use Filament\Tables\Columns\TextColumn;
use Filament\Forms\Components\TextInput;
use Filament\Tables\Columns\ImageColumn;
use Illuminate\Database\Eloquent\Builder;
use Filament\Forms\Components\RichEditor;
use Filament\Forms\Components\FileUpload;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use App\Filament\Resources\Panel\EmployeeResource\Pages;
use App\Filament\Resources\Panel\EmployeeResource\RelationManagers;
use Filament\Forms\Components\Checkbox;
use Filament\Tables\Columns\CheckboxColumn;

class EmployeeResource extends Resource
{
    protected static ?string $model = Employee::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?int $navigationSort = 1;

    protected static ?string $navigationGroup = 'البيانات الأساسيه';

    public static function getModelLabel(): string
    {
        return __('crud.employees.itemTitle');
    }

    public static function getPluralModelLabel(): string
    {
        return __('crud.employees.collectionTitle');
    }

    public static function getNavigationLabel(): string
    {
        return __('crud.employees.collectionTitle');
    }

    public static function form(Form $form): Form
    {
        return $form->schema([
            Section::make()->schema([
                Grid::make(['default' => 1])->schema([
                    TextInput::make('name')
                        ->required()
                        ->string()
                        ->unique('employees', 'name', ignoreRecord: true)
                        ->autofocus(),

                    TextInput::make('phone')
                        ->nullable()
                        ->string(),

                    RichEditor::make('address')
                        ->nullable()
                        ->string()
                        ->fileAttachmentsVisibility('public'),

                        // Checkbox::make('active')
                        // ->rules(['boolean'])
                        // ->nullable()
                        // ->inline(),
                        
                    FileUpload::make('photo')
                        ->rules(['image'])
                        ->nullable()
                        ->maxSize(1024)
                        ->image()
                        ->imageEditor()
                        ->imageEditorAspectRatios([null, '16:9', '4:3', '1:1']),
                ]),
            ]),
        ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->poll('60s')
            ->columns([
                TextColumn::make('name')->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),

                TextColumn::make('phone')->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),

                TextColumn::make('address')->limit(255)->badge()
                ->searchable()
                ->sortable()
                ->toggleable(),
               
                // CheckboxColumn::make('active'),

                ImageColumn::make('photo')->visibility('public'),
            ])
            ->filters([Tables\Filters\TrashedFilter::make()])
            ->actions([
                Tables\Actions\EditAction::make(),
                Tables\Actions\ViewAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),

                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->defaultSort('id', 'desc');
    }

    public static function getRelations(): array
    {
        return [];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListEmployees::route('/'),
            'create' => Pages\CreateEmployee::route('/create'),
            'view' => Pages\ViewEmployee::route('/{record}'),
            'edit' => Pages\EditEmployee::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()->withoutGlobalScopes([
            SoftDeletingScope::class,
        ]);
    }
}
